require 'modshogun'

f_feats_train = Modshogun::CSVFile.new "../../data/classifier_4class_2d_linear_features_train.dat"
f_feats_test = Modshogun::CSVFile.new "../../data/classifier_4class_2d_linear_features_test.dat"
f_labels_train = Modshogun::CSVFile.new "../../data/classifier_4class_2d_linear_labels_train.dat"
f_labels_test = Modshogun::CSVFile.new "../../data/classifier_4class_2d_linear_labels_test.dat"

#![create_features]
features_train = Modshogun::RealFeatures.new f_feats_train
features_test = Modshogun::RealFeatures.new f_feats_test
labels_train = Modshogun::MulticlassLabels.new f_labels_train
labels_test = Modshogun::MulticlassLabels.new f_labels_test
#![create_features]

#![create_instance]
k = 3
lmnn = Modshogun::LMNN.new features_train, labels_train, k
#![create_instance]

#![train_metric]
lmnn.train 
lmnn_distance = lmnn.get_distance 
#![train_metric]

#![train_and_apply]
knn = Modshogun::KNN.new k, lmnn_distance, labels_train
knn.train 
labels_predict = knn.apply_multiclass features_test
#![train_and_apply]

#![evaluate_accuracy]	
acc = Modshogun::MulticlassAccuracy.new 
accuracy = acc.evaluate labels_predict, labels_test
#![evaluate_accuracy]

# additional integration testing variables
output = labels_predict.get_labels 


# Serialize output for integration testing (automatically generated)
__sg_storage = Modshogun::WrappedObjectArray.new 
__sg_storage_file = Modshogun::SerializableAsciiFile.new "large_margin_nearest_neighbours.dat", 'w'
__sg_storage.append_wrapped_int k, "k"
__sg_storage.append_wrapped_real accuracy, "accuracy"
__sg_storage.append_wrapped_real_vector output, "output"
__sg_storage.save_serializable __sg_storage_file
